"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function encodeAnyArray(RTD) {
    return Buffer.from(JSON.stringify(RTD)).toString("base64");
}
function decodeAnyArray(RTD) {
    const v = JSON.parse(Buffer.from(RTD, "base64").toString());
    if (!Array.isArray(v)) {
        throw new TypeError("invalid RTS on continuation token");
    }
    return v;
}
exports.encode = (t) => {
    return `+RID:${t.RID}#RT:${t.RT}${t.SRC ? `#SRC:${t.SRC}` : ""}#TRC:${t.TRC}${typeof t.RTD !== "undefined" ? `#RTD:${encodeAnyArray(t.RTD)}` : ""}`;
};
exports.decode = (token) => {
    return token
        .slice(1)
        .split("#")
        .reduce((o, s) => {
        const i = s.indexOf(":");
        const key = s.slice(0, i);
        let value = s.slice(i + 1);
        switch (key) {
            case "RT":
            case "SRC":
            case "TRC":
                value = parseInt(value, 10);
                break;
            case "RTD":
                value = decodeAnyArray(value);
                break;
            default:
            // noop
        }
        // eslint-disable-next-line no-param-reassign
        o[key] = value;
        return o;
    }, {});
};
